package eu.mhsl.craftattack.spawn.appliances.whitelist;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;

public class PlayerJoinListener extends ApplianceListener<Whitelist> {
    @EventHandler
    public void preLoginEvent(AsyncPlayerPreLoginEvent preLoginEvent) {
        try {
            getAppliance().login(preLoginEvent);
        } catch (LoginException e) {
            preLoginEvent.disallow(
                    AsyncPlayerPreLoginEvent.Result.KICK_WHITELIST,
                    Component.text()
                            .appendNewline().appendNewline()
                            .append(Component.text(e.title, NamedTextColor.DARK_RED)).appendNewline()
                            .append(Component.text(e.error, NamedTextColor.RED)).appendNewline().appendNewline()
                            .append(Component.text(e.solution, NamedTextColor.GRAY)).appendNewline().appendNewline()
                            .append(Component.text(e.user.toString(), NamedTextColor.DARK_GRAY)).appendNewline()
                            .build()
            );
        }
    }
}
